import ConfigParser,cStringIO

import NeverData
import globals

class TileSetFile(ConfigParser.ConfigParser):
    def __init__(self):
        ConfigParser.ConfigParser.__init__(self)

    def fromFile(self,f):        
        self.readfp(f)

    def getTileCount(self):
        return self.getint('TILES','Count')
    
    def __str__(self):
        io = cStringIO.StringIO
        self.write(io)
        return io.value()

    def __repr__(self):
        return self.__str__()

class Tile(NeverData.NeverData):
    propList = {
        'Tile_AnimLoop1':'Boolean',
        'Tile_AnimLoop2':'Boolean',
        'Tile_AnimLoop3':'Boolean',
        'Tile_Height':'Integer,0-5',
        'Tile_ID':'Integer',
        'Tile_MainLight1':'Integer',#actually 2da index
        'Tile_MainLight2':'Integer',#actually 2da index
        'Tile_Orientation':'Integer,0-3',
        'Tile_SrcLight1':'Integer,0-15',
        'Tile_SrcLight2':'Integer,0-15'
        }

    def __init__(self,gffEntry,tileset):
        NeverData.NeverData.__init__(self)
        self.addPropList('main',self.propList,gffEntry)
        self.tileIndex = self.getProperty('Tile_ID')[1]
        self.modelName = tileset.get('TILE' + str(self.tileIndex),'Model') + '.mdl'
        self.model = globals.resourceManager.getResourceByName(self.modelName)

    def getName(self):
        return self.modelName
    
    def getModel(self):
        return self.model

    def getBearing(self):
        o = self.getProperty('Tile_Orientation')[1]
        if o == 0:
            return 0.0
        elif o == 1:
            return 90.0
        elif o == 2:
            return 180.0
        elif o == 3:
            return 270.0
        else:
            print 'warning, unknown tile orientation:',o
            return 0.0
    
if __name__ == '__main__':
    import sys
    t = TileSetFile()
    t.fromFile(open(sys.argv[1]))
    for i in t.items('GENERAL'):
        print i
        
